Index: code/branches/pickup2/src/libraries/core/ArgumentCompletionFunctions.cc
===================================================================
--- code/branches/pickup2/src/libraries/core/ArgumentCompletionFunctions.cc	(revision 6405)
+++ code/branches/pickup2/src/libraries/core/ArgumentCompletionFunctions.cc	(revision 6412)
@@ -72,5 +72,5 @@
                 else
                 {
-                    std::string dir = startdirectory.string();
+                    const std::string& dir = startdirectory.string();
                     if (dir.size() > 0 && dir[dir.size() - 1] == ':')
                         startdirectory = dir + '/';
@@ -84,7 +84,7 @@
                 {
                     if (boost::filesystem::is_directory(*file))
-                        dirlist.push_back(ArgumentCompletionListElement((*file).string() + '/', getLowercase((*file).string()) + '/', (*file).BOOST_LEAF_FUNCTION() + '/'));
+                        dirlist.push_back(ArgumentCompletionListElement(file->string() + '/', getLowercase(file->string()) + '/', file->BOOST_LEAF_FUNCTION() + '/'));
                     else
-                        filelist.push_back(ArgumentCompletionListElement((*file).string(), getLowercase((*file).string()), (*file).BOOST_LEAF_FUNCTION()));
+                        filelist.push_back(ArgumentCompletionListElement(file->string(), getLowercase(file->string()), file->BOOST_LEAF_FUNCTION()));
                     ++file;
                 }
@@ -101,6 +101,6 @@
 
             for (std::map<std::string, Identifier*>::const_iterator it = Identifier::getStringIdentifierMapBegin(); it != Identifier::getStringIdentifierMapEnd(); ++it)
-                if ((*it).second->hasConfigValues())
-                    classlist.push_back(ArgumentCompletionListElement((*it).second->getName(), getLowercase((*it).first)));
+                if (it->second->hasConfigValues())
+                    classlist.push_back(ArgumentCompletionListElement(it->first, getLowercase(it->first)));
 
             return classlist;
@@ -110,10 +110,10 @@
         {
             ArgumentCompletionList configvalues;
-            std::map<std::string, Identifier*>::const_iterator identifier = Identifier::getStringIdentifierMap().find(classname);
+            std::map<std::string, Identifier*>::const_iterator identifier = Identifier::getLowercaseStringIdentifierMap().find(getLowercase(classname));
 
-            if (identifier != Identifier::getStringIdentifierMapEnd() && (*identifier).second->hasConfigValues())
+            if (identifier != Identifier::getLowercaseStringIdentifierMapEnd() && identifier->second->hasConfigValues())
             {
-                for (std::map<std::string, ConfigValueContainer*>::const_iterator it = (*identifier).second->getConfigValueMapBegin(); it != (*identifier).second->getConfigValueMapEnd(); ++it)
-                    configvalues.push_back(ArgumentCompletionListElement((*it).second->getName(), getLowercase((*it).first)));
+                for (std::map<std::string, ConfigValueContainer*>::const_iterator it = identifier->second->getConfigValueMapBegin(); it != identifier->second->getConfigValueMapEnd(); ++it)
+                    configvalues.push_back(ArgumentCompletionListElement(it->first, getLowercase(it->first)));
             }
 
@@ -127,8 +127,8 @@
             if (identifier != Identifier::getLowercaseStringIdentifierMapEnd())
             {
-                std::map<std::string, ConfigValueContainer*>::const_iterator variable = (*identifier).second->getLowercaseConfigValueMap().find(getLowercase(varname));
-                if (variable != (*identifier).second->getLowercaseConfigValueMapEnd())
+                std::map<std::string, ConfigValueContainer*>::const_iterator variable = identifier->second->getLowercaseConfigValueMap().find(getLowercase(varname));
+                if (variable != identifier->second->getLowercaseConfigValueMapEnd())
                 {
-                    std::string valuestring = (*variable).second->toString();
+                    const std::string& valuestring = variable->second->toString();
                     oldvalue.push_back(ArgumentCompletionListElement(valuestring, getLowercase(valuestring), "Old value: " + valuestring));
                 }
Index: code/branches/pickup2/src/libraries/core/BaseObject.cc
===================================================================
--- code/branches/pickup2/src/libraries/core/BaseObject.cc	(revision 6405)
+++ code/branches/pickup2/src/libraries/core/BaseObject.cc	(revision 6412)
@@ -36,5 +36,4 @@
 #include <tinyxml/tinyxml.h>
 
-#include "util/StringUtils.h"
 #include "CoreIncludes.h"
 #include "Event.h"
@@ -119,5 +118,5 @@
         XMLPortObjectTemplate(BaseObject, Template, "templates", addTemplate, getTemplate, xmlelement, mode, Template*);
         XMLPortObject(BaseObject, BaseObject, "eventlisteners", addEventListener, getEventListener, xmlelement, mode);
-        
+
         Element* events = 0;
         if (mode == XMLPort::LoadObject || mode == XMLPort::ExpandObject)
@@ -139,5 +138,5 @@
         XMLPortEventState(BaseObject, BaseObject, "visibility", setVisible, xmlelement, mode);
         XMLPortEventState(BaseObject, BaseObject, "mainstate", setMainState, xmlelement, mode);
-        
+
         this->bRegisteredEventStates_ = true;
     }
@@ -236,5 +235,5 @@
             if (it->second != state)
                 continue;
-            
+
             if (i == index)
                 return it->first;
@@ -252,5 +251,5 @@
         listener->addEventSource(this, "mainstate");
     }
-    
+
     /**
         @brief Returns an event listener with a given index.
@@ -278,5 +277,5 @@
         if (it != this->eventStates_.end())
         {
-            COUT(2) << "Warning: Overwriting EventState in class " << this->getIdentifier()->getName() << "." << std::endl;
+            COUT(2) << "Warning: Overwriting EventState in class " << this->getIdentifier()->getName() << '.' << std::endl;
             delete (it->second);
         }
@@ -292,5 +291,5 @@
         std::map<std::string, EventState*>::const_iterator it = this->eventStates_.find(name);
         if (it != this->eventStates_.end())
-            return ((*it).second);
+            return (it->second);
         else
             return 0;
@@ -344,9 +343,9 @@
     {
         this->registerEventStates();
-        
+
         std::map<std::string, EventState*>::const_iterator it = this->eventStates_.find(event.statename_);
         if (it != this->eventStates_.end())
             it->second->process(event, this);
-        else if (event.statename_ != "")
+        else if (!event.statename_.empty())
             COUT(2) << "Warning: \"" << event.statename_ << "\" is not a valid state in object \"" << this->getName() << "\" of class " << this->getIdentifier()->getName() << "." << std::endl;
         else
@@ -356,5 +355,5 @@
     /**
         @brief Sets the main state of the object to a given boolean value.
-        
+
         Note: The main state of an object can be set with the @ref setMainStateName function.
         It's part of the eventsystem and used for event forwarding (when the target object can't specify a specific state,
@@ -386,8 +385,8 @@
         this->mainStateFunctor_ = 0;
 
-        if (this->mainStateName_ != "")
+        if (!this->mainStateName_.empty())
         {
             this->registerEventStates();
-            
+
             std::map<std::string, EventState*>::const_iterator it = this->eventStates_.find(this->mainStateName_);
             if (it != this->eventStates_.end() && it->second->getFunctor())
@@ -402,5 +401,5 @@
         }
     }
-    
+
     /**
         @brief Calls XMLEventPort with an empty XML-element to register the event states if necessary.
@@ -414,5 +413,5 @@
         }
     }
-    
+
     /**
         @brief Manually loads all event states, even if the class doesn't officially support them. This is needed by some classes like @ref EventDispatcher or @ref EventTarget.
@@ -437,5 +436,5 @@
             for (std::list<std::string>::iterator it = eventnames.begin(); it != eventnames.end(); ++it)
             {
-                std::string statename = (*it);
+                const std::string& statename = (*it);
 
                 // if the event state is already known, continue with the next state
@@ -447,6 +446,6 @@
                 if (!container)
                 {
-                    ExecutorMember<BaseObject>* setfunctor = createExecutor(createFunctor(&BaseObject::addEventSource), std::string( "BaseObject" ) + "::" + "addEventSource" + "(" + statename + ")");
-                    ExecutorMember<BaseObject>* getfunctor = createExecutor(createFunctor(&BaseObject::getEventSource), std::string( "BaseObject" ) + "::" + "getEventSource" + "(" + statename + ")");
+                    ExecutorMember<BaseObject>* setfunctor = createExecutor(createFunctor(&BaseObject::addEventSource), std::string( "BaseObject" ) + "::" + "addEventSource" + '(' + statename + ')');
+                    ExecutorMember<BaseObject>* getfunctor = createExecutor(createFunctor(&BaseObject::getEventSource), std::string( "BaseObject" ) + "::" + "getEventSource" + '(' + statename + ')');
                     setfunctor->setDefaultValue(1, statename);
                     getfunctor->setDefaultValue(1, statename);
Index: code/branches/pickup2/src/libraries/core/CMakeLists.txt
===================================================================
--- code/branches/pickup2/src/libraries/core/CMakeLists.txt	(revision 6405)
+++ code/branches/pickup2/src/libraries/core/CMakeLists.txt	(revision 6412)
@@ -29,4 +29,5 @@
   GraphicsManager.cc
   GUIManager.cc
+  IOConsole.cc
   Language.cc
   LuaState.cc
@@ -40,5 +41,5 @@
   CommandEvaluation.cc
   CommandExecutor.cc
-  CommandLine.cc
+  CommandLineParser.cc
   ConsoleCommand.cc
   ConsoleCommandCompilation.cc
@@ -85,6 +86,14 @@
   TOLUA_FILES
     CommandExecutor.h
+    ConfigFileManager.h
+    Game.h
+    GameMode.h
+    GUIManager.h
     Loader.h
     LuaState.h
+    PathConfig.h
+    input/InputManager.h
+    input/KeyBinder.h
+    input/KeyBinderManager.h
   DEFINE_SYMBOL
     "CORE_SHARED_BUILD"
Index: code/branches/pickup2/src/libraries/core/ClassTreeMask.cc
===================================================================
--- code/branches/pickup2/src/libraries/core/ClassTreeMask.cc	(revision 6405)
+++ code/branches/pickup2/src/libraries/core/ClassTreeMask.cc	(revision 6412)
@@ -291,4 +291,6 @@
     void ClassTreeMask::add(const Identifier* subclass, bool bInclude, bool overwrite, bool clean)
     {
+        if (!subclass)
+            return;
         // Check if the given subclass is a child of our root-class
         if (subclass->isA(this->root_->getClass()))
@@ -320,4 +322,6 @@
     void ClassTreeMask::add(ClassTreeMaskNode* node, const Identifier* subclass, bool bInclude, bool overwrite)
     {
+        if (!subclass)
+            return;
         // Check if the current node contains exactly the subclass we want to add
         if (subclass == node->getClass())
@@ -395,4 +399,6 @@
     void ClassTreeMask::addSingle(const Identifier* subclass, bool bInclude, bool clean)
     {
+        if (!subclass)
+            return;
         for (std::set<const Identifier*>::const_iterator it = subclass->getDirectChildrenBegin(); it != subclass->getDirectChildrenEnd(); ++it)
             this->add(*it, this->isIncluded(*it), false, false);
@@ -428,4 +434,6 @@
     bool ClassTreeMask::isIncluded(ClassTreeMaskNode* node, const Identifier* subclass) const
     {
+        if (!subclass)
+            return false;
         // Check if the searched subclass is of the same type as the class in the current node or a derivative
         if (subclass->isA(node->getClass()))
@@ -816,10 +824,10 @@
             // Calculate the prefix: + means included, - means excluded
             if (it->isIncluded())
-                out << "+";
+                out << '+';
             else
-                out << "-";
+                out << '-';
 
             // Put the name of the corresponding class on the stream
-            out << it->getClass()->getName() << " ";
+            out << it->getClass()->getName() << ' ';
         }
 
@@ -850,10 +858,10 @@
         // If there is a first subclass, move the object-iterator to the first object of this class. Else go to the end
         if (this->subclassIterator_ != this->subclasses_.end())
-            this->objectIterator_ = (*this->subclassIterator_).first->getObjects()->begin();
+            this->objectIterator_ = this->subclassIterator_->first->getObjects()->begin();
         else
             this->objectIterator_ = ObjectList<BaseObject>::end();
 
         // Check if the iterator points on a valid object. If not, go to the next object by calling ++
-        if (!this->objectIterator_ || ((*this->subclassIterator_).second && !this->objectIterator_->isExactlyA((*this->subclassIterator_).first)))
+        if (!this->objectIterator_ || (this->subclassIterator_->second && !this->objectIterator_->isExactlyA(this->subclassIterator_->first)))
             this->operator++();
 
@@ -882,5 +890,5 @@
                     // Check if there really is a next class. If yes, move the object-iterator to the first object
                     if (this->subclassIterator_ != this->subclasses_.end())
-                        this->objectIterator_ = (*this->subclassIterator_).first->getObjects()->begin();
+                        this->objectIterator_ = this->subclassIterator_->first->getObjects()->begin();
                     else
                         return (*this);
@@ -888,5 +896,5 @@
 
             // Repeat this until we reach a valid object or the end
-            } while ((*this->subclassIterator_).second && !this->objectIterator_->isExactlyA((*this->subclassIterator_).first));
+            } while (this->subclassIterator_->second && !this->objectIterator_->isExactlyA(this->subclassIterator_->first));
         }
         return (*this);
Index: code/branches/pickup2/src/libraries/core/CommandEvaluation.cc
===================================================================
--- code/branches/pickup2/src/libraries/core/CommandEvaluation.cc	(revision 6405)
+++ code/branches/pickup2/src/libraries/core/CommandEvaluation.cc	(revision 6412)
@@ -50,5 +50,5 @@
         this->commandTokens_.split(command, " ", SubString::WhiteSpaces, false, '\\', false, '"', false, '(', ')', false, '\0');
 
-        this->additionalParameter_ = "";
+        this->additionalParameter_.clear();
 
         this->bEvaluatedParams_ = false;
@@ -60,8 +60,8 @@
         this->functionclass_ = 0;
         this->function_ = 0;
-        this->possibleArgument_ = "";
-        this->argument_ = "";
-
-        this->errorMessage_ = "";
+        this->possibleArgument_.clear();
+        this->argument_.clear();
+
+        this->errorMessage_.clear();
         this->state_ = CommandState::Empty;
     }
@@ -79,5 +79,5 @@
         if (this->bEvaluatedParams_ && this->function_)
         {
-            COUT(6) << "CE_execute (evaluation): " << this->function_->getName() << " " << this->param_[0] << " " << this->param_[1] << " " << this->param_[2] << " " << this->param_[3] << " " << this->param_[4] << std::endl;
+            COUT(6) << "CE_execute (evaluation): " << this->function_->getName() << ' ' << this->param_[0] << ' ' << this->param_[1] << ' ' << this->param_[2] << ' ' << this->param_[3] << ' ' << this->param_[4] << std::endl;
             (*this->function_)(this->param_[0], this->param_[1], this->param_[2], this->param_[3], this->param_[4]);
             return true;
@@ -98,5 +98,5 @@
     }
 
-    std::string CommandEvaluation::complete()
+    const std::string& CommandEvaluation::complete()
     {
         if (!this->bNewCommand_)
@@ -114,8 +114,8 @@
                             return (this->command_ = this->function_->getName());
                         else
-                            return (this->command_ = this->function_->getName() + " ");
+                            return (this->command_ = this->function_->getName() + ' ');
                     }
                     else if (this->functionclass_)
-                        return (this->command_ = this->functionclass_->getName() + " ");
+                        return (this->command_ = this->functionclass_->getName() + ' ');
                     break;
                 case CommandState::Function:
@@ -123,7 +123,7 @@
                     {
                         if (this->function_->getParamCount() == 0)
-                            return (this->command_ = this->functionclass_->getName() + " " + this->function_->getName());
+                            return (this->command_ = this->functionclass_->getName() + ' ' + this->function_->getName());
                         else
-                            return (this->command_ = this->functionclass_->getName() + " " + this->function_->getName() + " ");
+                            return (this->command_ = this->functionclass_->getName() + ' ' + this->function_->getName() + ' ');
                     }
                     break;
@@ -131,5 +131,5 @@
                 case CommandState::Params:
                 {
-                    if (this->argument_ == "" && this->possibleArgument_ == "")
+                    if (this->argument_.empty() && this->possibleArgument_.empty())
                         break;
 
@@ -137,7 +137,7 @@
                     if (this->command_[this->command_.size() - 1] != ' ')
                         maxIndex -= 1;
-                    std::string whitespace = "";
-
-                    if (this->possibleArgument_ != "")
+                    std::string whitespace;
+
+                    if (!this->possibleArgument_.empty())
                     {
                         this->argument_ = this->possibleArgument_;
@@ -146,5 +146,5 @@
                     }
 
-                    return (this->command_ = this->commandTokens_.subSet(0, maxIndex).join() + " " + this->argument_ + whitespace);
+                    return (this->command_ = this->commandTokens_.subSet(0, maxIndex).join() + ' ' + this->argument_ + whitespace);
                     break;
                 }
@@ -262,11 +262,11 @@
     std::string CommandEvaluation::dump(const std::list<std::pair<const std::string*, const std::string*> >& list)
     {
-        std::string output = "";
+        std::string output;
         for (std::list<std::pair<const std::string*, const std::string*> >::const_iterator it = list.begin(); it != list.end(); ++it)
         {
             if (it != list.begin())
-                output += " ";
-
-            output += *(*it).second;
+                output += ' ';
+
+            output += *(it->second);
         }
         return output;
@@ -275,11 +275,11 @@
     std::string CommandEvaluation::dump(const ArgumentCompletionList& list)
     {
-        std::string output = "";
+        std::string output;
         for (ArgumentCompletionList::const_iterator it = list.begin(); it != list.end(); ++it)
         {
             if (it != list.begin())
-                output += " ";
-
-            output += (*it).getDisplay();
+                output += ' ';
+
+            output += it->getDisplay();
         }
         return output;
@@ -295,17 +295,17 @@
         {
             if (i != 0)
-                output += " ";
+                output += ' ';
 
             if (command->defaultValueSet(i))
-                output += "[";
+                output += '[';
             else
-                output += "{";
+                output += '{';
 
             output += command->getTypenameParam(i);
 
             if (command->defaultValueSet(i))
-                output += "=" + command->getDefaultValue(i).getString() + "]";
+                output += '=' + command->getDefaultValue(i).getString() + ']';
             else
-                output += "}";
+                output += '}';
         }
         return output;
Index: code/branches/pickup2/src/libraries/core/CommandEvaluation.h
===================================================================
--- code/branches/pickup2/src/libraries/core/CommandEvaluation.h	(revision 6405)
+++ code/branches/pickup2/src/libraries/core/CommandEvaluation.h	(revision 6412)
@@ -66,5 +66,5 @@
 
             bool execute() const;
-            std::string complete();
+            const std::string& complete();
             std::string hint() const;
             void evaluateParams();
@@ -82,5 +82,5 @@
                 { this->additionalParameter_ = param; this->bEvaluatedParams_ = false; }
             inline std::string getAdditionalParameter() const
-                { return (this->additionalParameter_ != "") ? (" " + this->additionalParameter_) : ""; }
+                { return (!this->additionalParameter_.empty()) ? (' ' + this->additionalParameter_) : ""; }
 
             void setEvaluatedParameter(unsigned int index, MultiType param);
